*! version 1.0.7, Ben Jann, 19may2005
program define estadd, rclass
	version 8.2
	syntax [anything] [ , Stats(passthru) * ]
	if `"`stats'"'!="" {
		_estadd2 `anything' , `stats' `options'
	}
	else {
		_estadd1 `anything' , `options'
	}
end

program define _estadd1, rclass
	syntax name(name=stat id="subcmd") [, Prefix(passthru) * ]
	est_expand .
	estadd_`stat' , `options' `prefix'
end

program define _estadd2, rclass
	syntax [anything] , Stats(string) [ Prefix(passthru) replace ]

//parse the stats() option
	ParseStats `stats'

//expand estimates names
	est_expand `"`anything'"' , default(.)
	local names `r(names)'

//determine active estimates and backup current (unstored) estimates
	local active "`e(_estimates_name)'"
	if "`active'"=="" & "`names'"!="." {
		tempname hcurrent
		_est hold `hcurrent', restore estsystem nullok
	}

//loop over estimates names and add the statistics
	nobreak {
		foreach name of local names {
			if "`name'"!="." estimates restore `name', noh drop
			else if "`hcurrent'"!="" _est unhold `hcurrent'
			capture {
				noisily {
					local s 0
					foreach stat in `stats' {
						local opt: word `++s' of `opts'
						qui estadd_`stat' , `opt' `prefix' `replace'
					}
				}
			}
			local rc = _rc
			if "`name'"!="." estimates store `name', title(`"`e(_estimates_title)'"')
			else if "`hcurrent'"!="" _est hold `hcurrent', restore estsystem
			if `rc' continue, break
		}
		if "`active'"!="" & "`active'"!="`name'" {
			estimates restore `active', drop noh
			estimates store `active', title(`"`e(_estimates_title)'"')
			/*same as -est restore- without -drop- option, but faster*/
			if "`hcurrent'"!="" _est unhold `hcurrent', not
		}
		else if "`hcurrent'"!="" _est unhold `hcurrent'
	}
	if `rc' exit `rc'
end

program define ParseStats
	gettoken stat 0: 0, parse(" (")
	gettoken trash 00: 0, match(par)
	gettoken opt: 0, match(par)
	while "`stat'"!="" {
		local stats: list stats | stat
		if `"`par'"'!="(" {
			gettoken stat 0: 0, parse(" (")
			local opts `"`opts'`""' "'
		}
		else {
			local opts `"`opts'`"`opt'"' "'
			gettoken stat 0: 00, parse(" (")
		}
		gettoken trash 00: 0, match(par)
		gettoken opt: 0, match(par)
	}
	c_local stats `stats'     // list of statistics: stat1 stat2 ...
	c_local opts `"`opts'"'   // list of options: `"opts1"' `"opts2"' ...
end
