*! version 1.0.0 29apr2005 Ben Jann (ETH Zurich)
prog define eststo
	version 8.2
	syntax [anything] using/ [, REPlace Label(str) id(varname) ]
	capt which estsave
	if _rc {
		di as error "-estsave- by Michael Blasnik required; type {stata ssc install estsave}"
		error 499
	}
	if "`id'"!="" {
		isid `id'
	}
	est_expand `"`anything'"' , default(.)
	local names `r(names)'
	tempname hcurrent
	_est hold `hcurrent', restore estsystem nullok
	preserve
	nobreak {
		foreach name of local names {
			if "`name'"=="." {
				_est unhold `hcurrent'
				local name2 _active
			}
			else {
				qui est restore `name', drop
				local name2 `name'
			}
			estsave , gen(_ests_`name2') replace
			local keep "`keep'_ests_`name2' "
			if "`name'"=="." _est hold `hcurrent', restore estsystem nullok
			else est sto `name', title(`"`e(_estimates_title)'"')
		}
	}
	keep `id' `keep'
	if "`id'"=="" qui drop in 1/l
	else sort `id'
	label data `"`label'"'
	qui notes drop _all
	save `"`using'"', `replace'
end
